Index: TOOLS/WATER_BUDGET/CPL_waterbudget.py
===================================================================
--- TOOLS/WATER_BUDGET/CPL_waterbudget.py	(revision 6620)
+++ TOOLS/WATER_BUDGET/CPL_waterbudget.py	(revision 6647)
@@ -278,177 +464,4 @@
 NbYear = dtime_sec / YearLength
 
-#-- Open restart files
-YearRes = YearBegin - 1        # Year of the restart of beginning of simulation
-YearPre = YearBegin - PackFrequency  # Year to find the tarfile of the restart of beginning of simulation
-
-config['Files']['YearPre'] = f'{YearBegin}'
-
-echo (f'Restart dates - Start : {YearRes}-12-31  /  End : {YearEnd}-12-31 ')
-
-if TarRestartPeriod_beg == None : 
-    echo (f'Restart dates - Start : {YearRes}-12-31  /  End : {YearEnd}-12-31 ')
-    TarRestartPeriod_beg = f'{YearPre}0101_{YearRes}1231'
-    config['Files']['TarRestartPeriod_beg'] = TarRestartPeriod_beg
-
-if TarRestartPeriod_end == None : 
-    YearPre = YearBegin - PackFrequency  # Year to find the tarfile of the restart of beginning of simulation
-    echo (f'Restart dates - Start : {YearRes}-12-31  /  End : {YearEnd}-12-31 ')
-    TarRestartPeriod_end = f'{YearBegin}0101_{YearEnd}1231'
-    config['Files']['TarRestartPeriod_end'] = TarRestartPeriod_end
-
-if tar_restart_beg == None :
-    tar_restart_beg = os.path.join ( R_SAVE, 'RESTART', f'{JobName}_{TarRestartPeriod_beg}_restart.tar' )
-    config['Files']['tar_restart_beg'] = tar_restart_beg
-if tar_restart_end == None :
-    tar_restart_end = os.path.join ( R_SAVE, 'RESTART', f'{JobName}_{TarRestartPeriod_end}_restart.tar' )
-    config['Files']['tar_restart_end'] = tar_restart_end
-
-echo ( f'{tar_restart_beg}' )
-echo ( f'{tar_restart_end}' )
-
-if file_ATM_beg == None : 
-    file_ATM_beg = f'{RunDir}/ATM_{JobName}_{YearRes}1231_restartphy.nc'
-    config['Files']['file_ATM_beg'] = file_ATM_beg
-if file_ATM_end == None :
-    file_ATM_end = f'{RunDir}/ATM_{JobName}_{YearEnd}1231_restartphy.nc'
-    config['Files']['file_ATM_end'] = file_ATM_end
-
-if file_DYN_beg == None :
-    if LMDZ : file_DYN_beg = f'{RunDir}/ATM_{JobName}_{YearRes}1231_restart.nc'
-    if ICO  : file_DYN_beg = f'{RunDir}/ICO_{JobName}_{YearRes}1231_restart.nc'
-    config['Files']['file_DYN_beg'] = file_DYN_beg
-    
-if file_DYN_end == None : 
-    if LMDZ : file_DYN_end = f'{RunDir}/ATM_{JobName}_{YearEnd}1231_restart.nc'
-    if ICO  : file_DYN_end = f'{RunDir}/ICO_{JobName}_{YearEnd}1231_restart.nc'
-    config['Files']['file_DYN_end'] = file_DYN_end
-    
-if file_SRF_beg == None :
-    file_SRF_beg = f'{RunDir}/SRF_{JobName}_{YearRes}1231_sechiba_rest.nc'
-    config['Files']['file_SRF_beg'] = file_SRF_beg
-if file_SRF_end == None :
-    file_SRF_end = f'{RunDir}/SRF_{JobName}_{YearEnd}1231_sechiba_rest.nc'
-    config['Files']['file_SRF_end'] = file_SRF_end
-    
-if file_OCE_beg == None : 
-    file_OCE_beg = f'{RunDir}/OCE_{JobName}_{YearRes}1231_restart.nc'
-    config['Files']['file_OCE_beg'] = file_OCE_beg
-if file_OCE_end == None :
-    file_OCE_end = f'{RunDir}/OCE_{JobName}_{YearEnd}1231_restart.nc'
-    config['Files']['file_OCE_end'] = file_OCE_end
-if file_ICE_beg == None :
-    file_ICE_beg = f'{RunDir}/ICE_{JobName}_{YearRes}1231_restart_icemod.nc'
-    config['Files']['file_ICE_beg'] = file_ICE_beg
-if file_ICE_end == None : 
-    file_ICE_end = f'{RunDir}/ICE_{JobName}_{YearEnd}1231_restart_icemod.nc'
-    config['Files']['file_ICE_end'] = file_ICE_end
-
-liste_beg = [file_ATM_beg, file_DYN_beg, file_SRF_beg]
-liste_end = [file_ATM_end, file_DYN_end, file_SRF_end]
-
-if Routing == 'SIMPLE' :
-    if file_RUN_beg == None : 
-        file_RUN_beg = f'{RunDir}/SRF_{JobName}_{YearRes}1231_routing_restart.nc'
-        config['Files']['file_RUN_beg'] = file_RUN_beg
-    if file_RUN_end == None : 
-        file_RUN_end = f'{RunDir}/SRF_{JobName}_{YearEnd}1231_routing_restart.nc'
-        config['Files']['file_RUN_end'] = file_RUN_end
-        
-    liste_beg.append ( file_RUN_beg )
-    liste_end.append ( file_RUN_end )
-    echo ( f'{file_RUN_beg = }' )
-    echo ( f'{file_RUN_end = }' )
-
-echo ( f'{file_ATM_beg = }' )
-echo ( f'{file_ATM_end = }' )
-echo ( f'{file_DYN_beg = }' )
-echo ( f'{file_DYN_end = }' )
-echo ( f'{file_SRF_beg = }' )
-echo ( f'{file_SRF_end = }' )
-echo ( f'{file_RUN_beg = }' )
-echo ( f'{file_RUN_end = }' )
-echo ( f'{file_OCE_beg = }' )
-echo ( f'{file_OCE_end = }' )
-echo ( f'{file_ICE_beg = }' )
-echo ( f'{file_ICE_end = }' )
-
-echo ('\nExtract restart files from tar : ATM, ICO and SRF')
-for resFile in liste_beg + liste_end :
-    if os.path.exists ( os.path.join (RunDir, resFile) ) :
-        echo ( f'file found : {resFile = }' )
-    else :
-        base_file = Path (file_name).stem # basename, and remove suffix
-        command =  f'cd {RunDir} ; tar xf {tar_restart_beg} {base_resFile}.nc'
-        echo ( command )
-        ierr = os.system ( command )
-        if ierr == 0 : echo ( f'tar done : {base_resFile}')
-        else         : raise Exception ( f'command failed : {command}' )
-
-echo ('\nOpening ATM SRF and ICO restart files')
-d_ATM_beg = xr.open_dataset ( os.path.join (RunDir, file_ATM_beg), decode_times=False, decode_cf=True).squeeze()
-d_ATM_end = xr.open_dataset ( os.path.join (RunDir, file_ATM_end), decode_times=False, decode_cf=True).squeeze()
-d_SRF_beg = xr.open_dataset ( os.path.join (RunDir, file_SRF_beg), decode_times=False, decode_cf=True).squeeze()
-d_SRF_end = xr.open_dataset ( os.path.join (RunDir, file_SRF_end), decode_times=False, decode_cf=True).squeeze()
-d_DYN_beg = xr.open_dataset ( os.path.join (RunDir, file_DYN_beg), decode_times=False, decode_cf=True).squeeze()
-d_DYN_end = xr.open_dataset ( os.path.join (RunDir, file_DYN_end), decode_times=False, decode_cf=True).squeeze()
-
-echo ('\nExtract and rebuild OCE and ICE restarts')
-def get_ndomain (zfile) :
-    #d_zfile = xr.open_dataset (zfile, decode_times=False).squeeze()
-    #ndomain_opa = d_zfile.attrs['DOMAIN_number_total']
-    #d_zfile.close ()
-    ndomain_opa = subprocess.getoutput ( f'ls {zfile}_*.nc | wc -l' ) #.format()
-    return int (ndomain_opa)
-
-def extract_and_rebuild ( file_name=file_OCE_beg, tar_restart=tar_restart_end, RunDirComp=RunDirOCE ) :
-    '''Extract restart file from tar. Rebuild ocean files if needed'''
-    echo ( f'file to extract : {file_name} ' )
-    if os.path.exists ( file_name ) :
-        echo ( f'-- File ready : {file_name}' )
-    else : 
-        echo ( f'-- Extracting {file_name}' )
-        base_resFile = Path (file_name).stem # basename, and remove suffix
-        # Try to extract the rebuilded file
-        command =  f'cd {RunDirComp} ; tar xf {tar_restart} {base_resFile}.nc'
-        echo ( command )
-        ierr = os.system ( command )
-        if ierr == 0 :
-            echo ( f'tar done : {base_resFile}')
-            command = f'cd {RunDirComp} ; mv {base_resFile}.nc {RunDir}'
-            ierr = os.system ( command )
-            if ierr == 0 : echo ( f'command done : {command}' )
-            else         : raise Exception ( f'command failed : {command}' )
-        else :
-            if not os.path.exists ( os.path.join (RunDir, f'{base_resFile}_0000.nc') ):
-                command =  f'cd {RunDirComp} ; tar xf {tar_restart_end} {base_resFile}_*.nc'
-                echo ( command )
-                ierr = os.system ( command )
-                if ierr == 0 : echo ( f'tar done : {file_OCE_beg}')
-                else         : raise Exception ( f'command failed : {command}' )
-                echo ('extract ndomain' )
-            ndomain_opa = get_ndomain ( os.path.join (RunDir, f'{base_resFile}') )
-            command = f'cd {RunDirComp} ; {rebuild} {base_resFile} {ndomain_opa} ; mv {base_resFile}.nc {RunDir}'
-            echo ( command )
-            ierr = os.system ( command )
-            if ierr == 0 : echo ( f'Rebuild done : {base_resFile}.nc')
-            else         : raise Exception ( f'command failed : {command}' )
-
-extract_and_rebuild ( file_name=file_OCE_beg, tar_restart=tar_restart_beg, RunDirComp=RunDirOCE )
-extract_and_rebuild ( file_name=file_OCE_end, tar_restart=tar_restart_end, RunDirComp=RunDirOCE )
-extract_and_rebuild ( file_name=file_ICE_beg, tar_restart=tar_restart_beg, RunDirComp=RunDirICE )
-extract_and_rebuild ( file_name=file_ICE_end, tar_restart=tar_restart_end, RunDirComp=RunDirICE )
-
-echo ('Opening OCE and ICE restart files')
-if NEMO == 3.6 : 
-    d_OCE_beg = xr.open_dataset ( os.path.join (RunDir, file_OCE_beg), decode_times=False, decode_cf=True, drop_variables=['y', 'x']).squeeze()
-    d_OCE_end = xr.open_dataset ( os.path.join (RunDir, file_OCE_end), decode_times=False, decode_cf=True).squeeze()
-    d_ICE_beg = xr.open_dataset ( os.path.join (RunDir, file_ICE_beg), decode_times=False, decode_cf=True).squeeze()
-    d_ICE_end = xr.open_dataset ( os.path.join (RunDir, file_ICE_end), decode_times=False, decode_cf=True).squeeze()
-if NEMO == 4.0 or NEMO == 4.2 : 
-    d_OCE_beg = xr.open_dataset ( os.path.join (RunDir, file_OCE_beg), decode_times=False, decode_cf=True, drop_variables=['y', 'x']).squeeze()
-    d_OCE_end = xr.open_dataset ( os.path.join (RunDir, file_OCE_end), decode_times=False, decode_cf=True, drop_variables=['y', 'x']).squeeze()
-    d_ICE_beg = xr.open_dataset ( os.path.join (RunDir, file_ICE_beg), decode_times=False, decode_cf=True, drop_variables=['y', 'x']).squeeze()
-    d_ICE_end = xr.open_dataset ( os.path.join (RunDir, file_ICE_end), decode_times=False, decode_cf=True, drop_variables=['y', 'x']).squeeze()
-
 ## Write the full configuration
 config_out = open (FullIniFile, 'w')
@@ -456,64 +469,69 @@
 config_out.close ()
 
-for var in d_SRF_beg.variables :
-    d_SRF_beg[var] = d_SRF_beg[var].where (  d_SRF_beg[var]<1.e20, 0.)
-    d_SRF_end[var] = d_SRF_end[var].where (  d_SRF_end[var]<1.e20, 0.)
-
-if ICO :
-    d_RUN_beg = xr.open_dataset ( os.path.join (RunDir, file_RUN_beg), decode_times=False, decode_cf=True).squeeze()
-    d_RUN_end = xr.open_dataset ( os.path.join (RunDir, file_RUN_end), decode_times=False, decode_cf=True).squeeze()
-
-def kg2Sv  (val, rho=OCE_rho_liq) :
-    '''From kg to Sverdrup'''
-    return val/dtime_sec*1.0e-6/rho
-
-def kg2myear (val, rho=OCE_rho_liq) :
-    '''From kg to m/year'''
-    return val/OCE_aire_tot/rho/NbYear
-
-def var2prt (var, small=False) :
-    if small :  return var , kg2Sv(var)*1000., kg2myear(var)*1000.
-    else     :  return var , kg2Sv(var)      , kg2myear(var)
-
-def prtFlux (Desc, var, Form='F', small=False) :
-    if small :
-        if Form in ['f', 'F'] : ff=" {:12.4e} kg | {:12.4f} mSv | {:12.4f} mm/year "
-        if Form in ['e', 'E'] : ff=" {:12.4e} kg | {:12.4e} mSv | {:12.4e} mm/year "
-    else :
-        if Form in ['f', 'F'] : ff=" {:12.4e} kg | {:12.4f} Sv  | {:12.4f} m/year  "
-        if Form in ['e', 'E'] : ff=" {:12.4e} kg | {:12.4e} Sv  | {:12.4e} m/year  "
-    echo ( (' {:>15} = ' +ff).format (Desc, *var2prt(var, small) ) )
-    return None
-
-
-
 # ATM grid with cell surfaces
+if LMDZ :
+    echo ('ATM grid with cell surfaces : LMDZ')
+    ATM_lat       = lmdz.geo2point (   rprec (d_ATM_his ['lat'])+0*rprec (d_ATM_his ['lon']), dim1D='cell' )
+    ATM_lon       = lmdz.geo2point ( 0*rprec (d_ATM_his ['lat'])+  rprec (d_ATM_his ['lon']), dim1D='cell' )
+    ATM_aire      = lmdz.geo2point ( rprec (d_ATM_his ['aire'] )    [0], cumulPoles=True, dim1D='cell' )
+    ATM_fter      = lmdz.geo2point ( rprec (d_ATM_his ['fract_ter'][0]), dim1D='cell' )
+    ATM_foce      = lmdz.geo2point ( rprec (d_ATM_his ['fract_oce'][0]), dim1D='cell' )
+    ATM_fsic      = lmdz.geo2point ( rprec (d_ATM_his ['fract_sic'][0]), dim1D='cell' )
+    ATM_flic      = lmdz.geo2point ( rprec (d_ATM_his ['fract_lic'][0]), dim1D='cell' )
+    SRF_lat       = lmdz.geo2point (   rprec (d_SRF_his ['lat'])+0*rprec (d_SRF_his ['lon']), dim1D='cell' )
+    SRF_lon       = lmdz.geo2point ( 0*rprec (d_SRF_his ['lat'])+  rprec (d_SRF_his ['lon']), dim1D='cell' )
+    SRF_aire      = lmdz.geo2point ( rprec (d_SRF_his ['Areas']) * rprec (d_SRF_his ['Contfrac']), dim1D='cell', cumulPoles=True )
+    SRF_areas     = lmdz.geo2point ( rprec (d_SRF_his ['Areas'])  ,  dim1D='cell', cumulPoles=True )
+    SRF_contfrac  = lmdz.geo2point ( rprec (d_SRF_his ['Contfrac']), dim1D='cell' )
 if ICO :
     if ATM_HIS == 'latlon' :
-        jpja, jpia = d_ATM_his['aire'][0].shape   
-        file_ATM_aire = os.path.join ( R_IN, 'ATM', 'GRID', f'aire_{ATM}_to_{jpia}x{jpja}.nc' )
-        config['Files']['file_ATM_aire'] = file_ATM_aire
-        echo ( f'Aire sur grille reguliere : {file_ATM_aire = }' )
-        d_ATM_aire = xr.open_dataset ( file_ATM_aire, decode_times=False ).squeeze()
-        ATM_aire = lmdz.geo2point ( d_ATM_aire ['aire'].squeeze(), cumulPoles=True )
-        ATM_fter = lmdz.geo2point ( d_ATM_his ['fract_ter'][0] )
-        ATM_foce = lmdz.geo2point ( d_ATM_his ['fract_oce'][0] )
-        ATM_fsic = lmdz.geo2point ( d_ATM_his ['fract_sic'][0] )
-        ATM_flic = lmdz.geo2point ( d_ATM_his ['fract_lic'][0] )
-        SRF_aire = lmdz.geo2point ( d_SRF_his ['Areas'] * d_SRF_his ['Contfrac'] )
-        #SRF_aire = ATM_aire * lmdz.geo2point (d_SRF_his ['Contfrac'] )
-        #SRF_aire = ATM_aire * ATM_fter
+        echo ( 'ATM areas and fractions on latlon grid' )
+        if 'lat_dom_out' in d_ATM_his.variables :
+            ATM_lat  = lmdz.geo2point (   rprec (d_ATM_his ['lat_dom_out'])+0*rprec (d_ATM_his ['lon_dom_out']), dim1D='cell' )
+            ATM_lon  = lmdz.geo2point ( 0*rprec (d_ATM_his ['lat_dom_out'])+  rprec (d_ATM_his ['lon_dom_out']), dim1D='cell' )
+        else :
+            ATM_lat  = lmdz.geo2point (   rprec (d_ATM_his ['lat'])+0*rprec (d_ATM_his ['lon']), dim1D='cell' )
+            ATM_lon  = lmdz.geo2point ( 0*rprec (d_ATM_his ['lat'])+  rprec (d_ATM_his ['lon']), dim1D='cell' )
+        ATM_aire = lmdz.geo2point ( rprec (d_ATM_his ['aire'][0]).squeeze(), cumulPoles=True, dim1D='cell' )
+        ATM_fter = lmdz.geo2point ( rprec (d_ATM_his ['fract_ter'][0]), dim1D='cell' )
+        ATM_foce = lmdz.geo2point ( rprec (d_ATM_his ['fract_oce'][0]), dim1D='cell' )
+        ATM_fsic = lmdz.geo2point ( rprec (d_ATM_his ['fract_sic'][0]), dim1D='cell' )
+        ATM_flic = lmdz.geo2point ( rprec (d_ATM_his ['fract_lic'][0]), dim1D='cell' )
+
     if ATM_HIS == 'ico' :
-        echo ( f'Aire sur grille icosaedre : {file_ATM_aire = }' )
-        
-if LMDZ :
-    ATM_aire = lmdz.geo2point ( d_ATM_his ['aire'][0], cumulPoles=True )
-    ATM_fter = lmdz.geo2point ( d_ATM_his ['fract_ter'][0] )
-    ATM_foce = lmdz.geo2point ( d_ATM_his ['fract_oce'][0] )
-    ATM_fsic = lmdz.geo2point ( d_ATM_his ['fract_sic'][0] )
-    ATM_flic = lmdz.geo2point ( d_ATM_his ['fract_lic'][0] )
-    #SRF_aire = lmdz.geo2point ( d_SRF_his['Areas'] * d_SRF_his['Contfrac'] )
-    SRF_aire = ATM_aire * lmdz.geo2point ( d_SRF_his['Contfrac'] )
-    
+        echo ( 'ATM areas and fractions on ICO grid' )
+        ATM_aire =  rprec (d_ATM_his ['aire']     [0]).squeeze()
+        ATM_lat  =  rprec (d_ATM_his ['lat']         )
+        ATM_lon  =  rprec (d_ATM_his ['lon']         )
+        ATM_fter =  rprec (d_ATM_his ['fract_ter'][0])
+        ATM_foce =  rprec (d_ATM_his ['fract_oce'][0])
+        ATM_fsic =  rprec (d_ATM_his ['fract_sic'][0])
+        ATM_flic =  rprec (d_ATM_his ['fract_lic'][0])
+
+    if SRF_HIS == 'latlon' :
+        echo ( 'SRF areas and fractions on latlon grid' )
+        if 'lat_domain_landpoints_out' in d_SRF_his  : 
+            SRF_lat  = lmdz.geo2point (   rprec (d_SRF_his ['lat_domain_landpoints_out'])+0*rprec (d_SRF_his ['lon_domain_landpoints_out']), dim1D='cell' )
+            SRF_lon  = lmdz.geo2point ( 0*rprec (d_SRF_his ['lat_domain_landpoints_out'])+  rprec (d_SRF_his ['lon_domain_landpoints_out']), dim1D='cell' )
+        else : 
+            if 'lat_domain_landpoints_out' in d_SRF_his :
+                SRF_lat  = lmdz.geo2point (   rprec (d_SRF_his ['lat_dom_out'])+0*rprec (d_SRF_his ['lon_dom_out']), dim1D='cell' )
+                SRF_lon  = lmdz.geo2point ( 0*rprec (d_SRF_his ['lat_dom_out'])+  rprec (d_SRF_his ['lon_dom_out']), dim1D='cell' )
+            else :
+                SRF_lat  = lmdz.geo2point (   rprec (d_SRF_his ['lat'])+0*rprec (d_SRF_his ['lon']), dim1D='cell' )
+                SRF_lon  = lmdz.geo2point ( 0*rprec (d_SRF_his ['lat'])+  rprec (d_SRF_his ['lon']), dim1D='cell' )
+                
+        SRF_areas     = lmdz.geo2point ( rprec (d_SRF_his ['Areas']   )   , dim1D='cell', cumulPoles=True )
+        SRF_areafrac  = lmdz.geo2point ( rprec (d_SRF_his ['AreaFrac'])   , dim1D='cell', cumulPoles=True )
+        SRF_contfrac  = lmdz.geo2point ( rprec (d_SRF_his ['Contfrac'])   , dim1D='cell', cumulPoles=True )
+        SRF_aire = SRF_areafrac
+ 
+    if SRF_HIS == 'ico' :
+        echo ( 'SRF areas and fractions on latlon grid' )
+        SRF_lat       =  rprec (d_SRF_his ['lat']     )
+        SRF_lon       =  rprec (d_SRF_his ['lon']     )
+        SRF_areas     =  rprec (d_SRF_his ['Areas']   ) 
+        SRF_contfrac  =  rprec (d_SRF_his ['Contfrac'])
+        SRF_aire      =  SRF_areas * SRF_contfrac
 ATM_fsea      = ATM_foce + ATM_fsic
 ATM_flnd      = ATM_fter + ATM_flic
@@ -525,28 +543,38 @@
 ATM_aire_fsea = ATM_aire * ATM_fsea
 
-SRF_aire = SRF_aire.where ( SRF_aire < 1E15, 0.)
-
-if ICO :
-    # Area on icosahedron grid
-    file_DYN_aire = os.path.join ( R_IN, 'ATM', 'GRID', ATM+'_grid.nc' )
-    d_DYN_aire = xr.open_dataset ( file_DYN_aire, decode_times=False).squeeze()
-    d_DYN_aire = d_DYN_aire.rename ( {'cell':'cell_mesh'} )
-    DYN_aire   = d_DYN_aire['aire']
-
-    DYN_fsea = d_DYN_aire ['fract_oce'] + d_DYN_aire ['fract_sic']
-    DYN_flnd = 1.0 - DYN_fsea
-    
-if LMDZ :
-    # Area on lon/lat grid
-    DYN_aire = ATM_aire
-    DYN_fsea = ATM_fsea
-    DYN_flnd = ATM_flnd
-    DYN_fter = d_ATM_beg['FTER']
-    DYN_flic = d_ATM_beg['FTER']
-
-def ATM_stock_int (stock) :
-    '''Integrate (* surface) stock on atmosphere grid'''
-    ATM_stock_int  = wu.Psum ( (stock * DYN_aire).to_masked_array().ravel() ) 
-    return ATM_stock_int
+#SRF_aire = SRF_aire.where ( SRF_aire < 1E15, 0.)
+
+# if ICO :
+#     if wu.unDefined ('file_DYN_aire') : file_DYN_aire = os.path.join ( R_IN, 'ATM', 'GRID', ATM+'_grid.nc' )
+#     config['Files']['file_DYN_aire'] = file_DYN_aire
+
+# if ICO :
+#     # Area on icosahedron grid
+#     d_DYN_aire = xr.open_dataset ( file_DYN_aire, decode_times=False ).squeeze()
+           
+#     DYN_lat = d_DYN_aire['lat']
+#     DYN_lon = d_DYN_aire['lon']
+
+#     DYN_aire = d_DYN_aire['aire']
+#     DYN_fsea = d_DYN_aire['fract_oce'] + d_DYN_aire['fract_sic']
+#     DYN_flnd = 1.0 - DYN_fsea
+#     DYN_fter = d_ATM_beg['FTER']
+#     DYN_flic = d_ATM_beg['FLIC']
+#     DYN_aire_fter = DYN_aire * DYN_fter
+    
+# if LMDZ :
+#     # Area on lon/lat grid
+#     DYN_aire = ATM_aire
+#     DYN_fsea = ATM_fsea
+#     DYN_flnd = ATM_flnd
+#     DYN_fter = rprec (d_ATM_beg['FTER'])
+#     DYN_flic = rprec (d_ATM_beg['FLIC'])
+#     DYN_aire_fter = DYN_aire * DYN_fter
+
+# Functions computing integrals and sum
+# def ATM_stock_int (stock) :
+#     '''Integrate (* surface) stock on atmosphere grid'''
+#     ATM_stock_int  = wu.Psum ( (stock * DYN_aire).to_masked_array().ravel() ) 
+#     return ATM_stock_int
 
 def ATM_flux_int (flux) :
@@ -555,8 +583,8 @@
     return ATM_flux_int
 
-def SRF_stock_int (stock) :
-    '''Integrate (* surface) stock on land grid'''
-    ATM_stock_int  = wu.Ksum (  ( (stock * DYN_aire_fter).to_masked_array().ravel()) )
-    return ATM_stock_int
+# def SRF_stock_int (stock) :
+#     '''Integrate (* surface) stock on land grid'''
+#     ATM_stock_int  = wu.Ksum (  ( (stock * DYN_aire_fter).to_masked_array().ravel()) )
+#     return ATM_stock_int
 
 def SRF_flux_int (flux) :
@@ -565,8 +593,13 @@
     return SRF_flux_int
 
-def OCE_stock_int (stock) :
-    '''Integrate stock on ocean grid'''
-    OCE_stock_int = np.sum (  np.sort ( (stock * OCE_aire ).to_masked_array().ravel()) )
-    return OCE_stock_int
+def LIC_flux_int (flux) :
+    '''Integrate (* time * surface) flux on land ice grid'''
+    LIC_flux_int  = wu.Psum ( (flux * dtime_per_sec * ATM_aire_flic).to_masked_array().ravel() )
+    return LIC_flux_int
+
+# def OCE_stock_int (stock) :
+#     '''Integrate stock on ocean grid'''
+#     OCE_stock_int = np.sum (  np.sort ( (stock * OCE_aire ).to_masked_array().ravel()) )
+#     return OCE_stock_int
 
 def ONE_stock_int (stock) :
@@ -584,7 +617,4 @@
     OCE_flux_int = np.sum (  np.sort ( (flux * dtime_per_sec).to_masked_array().ravel()) )
     return OCE_flux_int
-    
-#if LMDZ :
-#    d_ATM_beg = d_ATM_beg.assign ( coords={'lon':d_ATM_beg.lon*180./np.pi} )
 
 # Get mask and surfaces
